cmdline/apt-key: Create new keyrings with mode 0644 instead of 0600
[ntk/apt.git] / cmdline / apt-key
1 #!/bin/sh
2
3 set -e
4 unset GREP_OPTIONS
5
6 # We don't use a secret keyring, of course, but gpg panics and
7 # implodes if there isn't one available
8 SECRETKEYRING="$(mktemp)"
9 trap "rm -f '${SECRETKEYRING}'" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
10 GPG_CMD="gpg --ignore-time-conflict --no-options --no-default-keyring --secret-keyring ${SECRETKEYRING}"
11
12 if [ "$(id -u)" -eq 0 ]; then
13 # we could use a tmpfile here too, but creation of this tends to be time-consuming
14 eval $(apt-config shell TRUSTDBDIR Dir::Etc/d)
15 GPG_CMD="$GPG_CMD --trustdb-name ${TRUSTDBDIR}/trustdb.gpg"
16 fi
17
18 GPG="$GPG_CMD"
19
20 MASTER_KEYRING=""
21 ARCHIVE_KEYRING_URI=""
22 #MASTER_KEYRING=/usr/share/keyrings/debian-master-keyring.gpg
23 #ARCHIVE_KEYRING_URI=http://ftp.debian.org/debian/debian-archive-keyring.gpg
24
25 ARCHIVE_KEYRING=/usr/share/keyrings/debian-archive-keyring.gpg
26 REMOVED_KEYS=/usr/share/keyrings/debian-archive-removed-keys.gpg
27
28 requires_root() {
29 if [ "$(id -u)" -ne 0 ]; then
30 echo >&1 "ERROR: This command can only be used by root."
31 exit 1
32 fi
33 }
34
35 # gpg defaults to mode 0600 for new keyrings. Create one with 0644 instead.
36 init_keyring() {
37 for path; do
38 if ! [ -e "$path" ]; then
39 touch -- "$path"
40 chmod 0644 -- "$path"
41 fi
42 done
43 }
44
45 add_keys_with_verify_against_master_keyring() {
46 ADD_KEYRING=$1
47 MASTER=$2
48
49 if [ ! -f "$ADD_KEYRING" ]; then
50 echo "ERROR: '$ADD_KEYRING' not found"
51 return
52 fi
53 if [ ! -f "$MASTER" ]; then
54 echo "ERROR: '$MASTER' not found"
55 return
56 fi
57
58 # when adding new keys, make sure that the archive-master-keyring
59 # is honored. so:
60 # all keys that are exported must have a valid signature
61 # from a key in the $distro-master-keyring
62 add_keys=`$GPG_CMD --keyring $ADD_KEYRING --with-colons --list-keys | grep ^pub | cut -d: -f5`
63 master_keys=`$GPG_CMD --keyring $MASTER --with-colons --list-keys | grep ^pub | cut -d: -f5`
64 for add_key in $add_keys; do
65 ADDED=0
66 for master_key in $master_keys; do
67 if $GPG_CMD --keyring $ADD_KEYRING --list-sigs --with-colons $add_key | grep ^sig | cut -d: -f5 | grep -q $master_key; then
68 $GPG_CMD --quiet --batch --keyring $ADD_KEYRING --export $add_key | $GPG --import
69 ADDED=1
70 fi
71 done
72 if [ $ADDED = 0 ]; then
73 echo >&2 "Key '$add_key' not added. It is not signed with a master key"
74 fi
75 done
76 }
77
78 # update the current archive signing keyring from a network URI
79 # the archive-keyring keys needs to be signed with the master key
80 # (otherwise it does not make sense from a security POV)
81 net_update() {
82 if [ -z "$ARCHIVE_KEYRING_URI" ]; then
83 echo >&2 "ERROR: Your distribution is not supported in net-update as no uri for the archive-keyring is set"
84 exit 1
85 fi
86 requires_root
87 # in theory we would need to depend on wget for this, but this feature
88 # isn't useable in debian anyway as we have no keyring uri nor a master key
89 if ! which wget >/dev/null 2>&1; then
90 echo >&2 "ERROR: an installed wget is required for a network-based update"
91 exit 1
92 fi
93 if [ ! -d /var/lib/apt/keyrings ]; then
94 mkdir -p /var/lib/apt/keyrings
95 fi
96 keyring=/var/lib/apt/keyrings/$(basename $ARCHIVE_KEYRING)
97 old_mtime=0
98 if [ -e $keyring ]; then
99 old_mtime=$(stat -c %Y $keyring)
100 fi
101 (cd /var/lib/apt/keyrings; wget -q -N $ARCHIVE_KEYRING_URI)
102 if [ ! -e $keyring ]; then
103 return
104 fi
105 new_mtime=$(stat -c %Y $keyring)
106 if [ $new_mtime -ne $old_mtime ]; then
107 echo "Checking for new archive signing keys now"
108 add_keys_with_verify_against_master_keyring $keyring $MASTER_KEYRING
109 fi
110 }
111
112 update() {
113 if [ ! -f $ARCHIVE_KEYRING ]; then
114 echo >&2 "ERROR: Can't find the archive-keyring"
115 echo >&2 "Is the debian-archive-keyring package installed?"
116 exit 1
117 fi
118 requires_root
119
120 # add new keys from the package;
121
122 # we do not use add_keys_with_verify_against_master_keyring here,
123 # because "update" is run on regular package updates. A
124 # attacker might as well replace the master-archive-keyring file
125 # in the package and add his own keys. so this check wouldn't
126 # add any security. we *need* this check on net-update though
127 $GPG_CMD --quiet --batch --keyring $ARCHIVE_KEYRING --export | $GPG --import
128
129 if [ -r "$REMOVED_KEYS" ]; then
130 # remove no-longer supported/used keys
131 keys=`$GPG_CMD --keyring $REMOVED_KEYS --with-colons --list-keys | grep ^pub | cut -d: -f5`
132 for key in $keys; do
133 if $GPG --list-keys --with-colons | grep ^pub | cut -d: -f5 | grep -q $key; then
134 $GPG --quiet --batch --delete-key --yes ${key}
135 fi
136 done
137 else
138 echo "Warning: removed keys keyring $REMOVED_KEYS missing or not readable" >&2
139 fi
140 }
141
142
143 usage() {
144 echo "Usage: apt-key [--keyring file] [command] [arguments]"
145 echo
146 echo "Manage apt's list of trusted keys"
147 echo
148 echo " apt-key add <file> - add the key contained in <file> ('-' for stdin)"
149 echo " apt-key del <keyid> - remove the key <keyid>"
150 echo " apt-key export <keyid> - output the key <keyid>"
151 echo " apt-key exportall - output all trusted keys"
152 echo " apt-key update - update keys using the keyring package"
153 echo " apt-key net-update - update keys using the network"
154 echo " apt-key list - list keys"
155 echo " apt-key finger - list fingerprints"
156 echo " apt-key adv - pass advanced options to gpg (download key)"
157 echo
158 echo "If no specific keyring file is given the command applies to all keyring files."
159 }
160
161 # Determine on which keyring we want to work
162 if [ "$1" = "--keyring" ]; then
163 #echo "keyfile given"
164 shift
165 TRUSTEDFILE="$1"
166 if [ -r "$TRUSTEDFILE" ] || [ "$2" = 'add' ]; then
167 GPG="$GPG --keyring $TRUSTEDFILE --primary-keyring $TRUSTEDFILE"
168 else
169 echo >&2 "Error: The specified keyring »$TRUSTEDFILE« is missing or not readable"
170 exit 1
171 fi
172 shift
173 # otherwise use the default
174 else
175 #echo "generate list"
176 TRUSTEDFILE="/etc/apt/trusted.gpg"
177 eval $(apt-config shell TRUSTEDFILE Apt::GPGV::TrustedKeyring)
178 eval $(apt-config shell TRUSTEDFILE Dir::Etc::Trusted/f)
179 if [ -r "$TRUSTEDFILE" ]; then
180 GPG="$GPG --keyring $TRUSTEDFILE"
181 fi
182 GPG="$GPG --primary-keyring $TRUSTEDFILE"
183 TRUSTEDPARTS="/etc/apt/trusted.gpg.d"
184 eval $(apt-config shell TRUSTEDPARTS Dir::Etc::TrustedParts/d)
185 if [ -d "$TRUSTEDPARTS" ]; then
186 #echo "parts active"
187 for trusted in $(run-parts --list $TRUSTEDPARTS --regex '^.*\.gpg$'); do
188 #echo "part -> $trusted"
189 GPG="$GPG --keyring $trusted"
190 done
191 fi
192 fi
193 #echo "COMMAND: $GPG"
194
195 command="$1"
196 if [ -z "$command" ]; then
197 usage
198 exit 1
199 fi
200 shift
201
202 if [ "$command" != "help" ] && ! which gpg >/dev/null 2>&1; then
203 echo >&2 "Warning: gnupg does not seem to be installed."
204 echo >&2 "Warning: apt-key requires gnupg for most operations."
205 echo >&2
206 fi
207
208 case "$command" in
209 add)
210 requires_root
211 init_keyring "$TRUSTEDFILE"
212 $GPG --quiet --batch --import "$1"
213 echo "OK"
214 ;;
215 del|rm|remove)
216 requires_root
217 init_keyring "$TRUSTEDFILE"
218 $GPG --quiet --batch --delete-key --yes "$1"
219 echo "OK"
220 ;;
221 update)
222 init_keyring "$TRUSTEDFILE"
223 update
224 ;;
225 net-update)
226 init_keyring "$TRUSTEDFILE"
227 net_update
228 ;;
229 list)
230 init_keyring "$TRUSTEDFILE"
231 $GPG --batch --list-keys
232 ;;
233 finger*)
234 init_keyring "$TRUSTEDFILE"
235 $GPG --batch --fingerprint
236 ;;
237 export)
238 init_keyring "$TRUSTEDFILE"
239 $GPG --armor --export "$1"
240 ;;
241 exportall)
242 init_keyring "$TRUSTEDFILE"
243 $GPG --armor --export
244 ;;
245 adv*)
246 init_keyring "$TRUSTEDFILE"
247 echo "Executing: $GPG $*"
248 $GPG $*
249 ;;
250 help)
251 usage
252 ;;
253 *)
254 usage
255 exit 1
256 ;;
257 esac